#include <qpid/client/Connection.h>
#include <qpid/client/Session.h>
#include <qpid/client/Message.h>


#include <unistd.h>
#include <cstdlib>
#include <iostream>

#include <sstream>

#include <stdio.h>
#include <unistd.h>     // For pause()
#include <sys/time.h>
#include <signal.h>     // For signal


using namespace qpid::client;
using namespace qpid::framing;

using namespace std;


void
print_timestamp ( char const * q_name )
{
  char timestamp[1000];

  time_t rawtime;
  time ( & rawtime );
  struct tm * timeinfo = localtime ( &rawtime );
  int seconds;

  // Prints the "second number" for the current momment.
  seconds = timeinfo->tm_hour * 3600 +
            timeinfo->tm_min  * 60   +
            timeinfo->tm_sec;

  sprintf ( timestamp, "%d", seconds );

  char file_name[1000];
  sprintf ( file_name, "senders_started/%s", q_name );
  FILE * fp = fopen ( file_name, "w" );
  fprintf ( fp, "%s\n", timestamp );
  fclose ( fp );
}



static volatile int pause_time     = 140000;
static volatile int message_burst  = 50;

void
micks_magic_function ( )
{
  int result = 0;
  char word[100];
  int value = 0;
  FILE * fp = fopen ( "/tmp/dp", "r" );
  if ( fp )
  {
    result = 2;

    while ( result == 2 )
    {
      result = fscanf ( fp, "%s%d", word, & value );
      if ( * word == 'p' )
      {
        if ( value != pause_time )
        {
          pause_time = value;
          fprintf ( stderr, "pause_time set to %d\n", pause_time );
        }
      }
      else
      if ( * word == 'm' )
      {
        if ( value != message_burst )
        {
          message_burst = value;
          fprintf ( stderr, "message_burst set to %d\n", message_burst );
        }
      }
    }
    fclose ( fp );
  }
}






int 
main ( int argc, char** argv ) 
{
  // set up timer ----------------------------------------
  struct itimerval timer;
  timer.it_value.tv_sec  = 30;
  timer.it_value.tv_usec = 0;
  timer.it_interval = timer.it_value;
  signal ( SIGALRM, (void (*)(int)) micks_magic_function );
  setitimer ( ITIMER_REAL, & timer, NULL );


  const char* host   =      argv[1];
  int port           = atoi(argv[2]);
  char const* q_name =      argv[3];
  int count          = atoi(argv[4]);

  Connection connection;
  Message message;

  char routing_key [ 1000 ];

  stringstream message_data;
  message_data.str ( "" );
  message_data << "All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a dull boy.  All work and no play make Mick a";

  message.setData ( message_data.str() );

  try
  {
    connection.open(host, port);
    Session session =  connection.newSession();

    print_timestamp ( q_name );

    // Send each message ..... 
    for ( int i = 0; i < count; ++ i ) 
    {
      message.getDeliveryProperties().setRoutingKey ( q_name );
      session.messageTransfer ( arg::content=message,  arg::destination="fed_exchange" );

      // If we have sent a burst -- pause.
      if ( ! ( i % message_burst ) )
      {
        if ( pause_time > 0 )
        {
          usleep ( pause_time );
        }
      }

    }

    // Say Goodbye to each queue ----------------------------------------
    message_data.str ( "" );
    message_data << "quit";
    message.setData(message_data.str());

    message.getDeliveryProperties().setRoutingKey ( q_name );
    session.messageTransfer(arg::content=message,  arg::destination="fed_exchange");
  }
  catch ( const std::exception& error )
  {
    std::cout << error.what() << std::endl;
  }

  connection.close();

  return 0;
}





